clear a b; tic;

% principal axis/common factor analysis with SMCs on the diagonal

smc = 1 - (1 ./ diag(inv(r)));
rdum = r;
for ii=1:size(r,1);rdum(ii,ii) = smc(ii,1);end;
realevals = flipud(sort(eig(rdum)));


variables = size(r,1);  % number of variables.

for a = 1:Ndatsets 
rdum2 = corrcoef(randn(cases,variables));
smc = 1 - (1 ./ diag(inv(rdum2)));
for ii=1:size(rdum2,1);rdum2(ii,ii) = smc(ii,1);end;
evals(:,a) = eig(rdum2);
end


evals = flipud(sort(evals,1));
means = (mean(evals,2));   % mean eigenvalues for each position.
evals = sort(evals,2);     % sorting the eigenvalues for each position.
percentiles = (evals(:,round((percent*Ndatsets)/100)));  % percentiles.


for root = 1:variables;
if realevals(root,1) < percentiles(root,1) 
nfPARPAF = root - 1;
break;end;end;
	

clear evals



%disp(['   Parallel Analysis ']); disp([' '])
%disp(['Variables  = ' num2str(variables) ]);
%disp(['Cases      = ' num2str(cases) ]);
%disp(['Ndatsets     = ' num2str(Ndatsets) ]);
%disp(['Percentile = ' num2str(percent) ]); disp([' '])
%disp(['     Root'  '     Means'  '     Percent' '    Eigen' ])
%disp([(1:variables).'  means percentiles realevals])
%disp(['Parallel Analysis: Number of Factors =  '  num2str(nfPAR) ]);; disp([' '])
%disp(['time for this problem = ', num2str(toc) ]); disp([' '])
		
		
