% Promax rotation -- Marcus, 1993

% the loadings are first rotated to an orthogonal varimax solution, then the
% orthogonality of the factors is relaxed to better fit simple structure 
% (Mulaik 1972 p 300; Rummel 1970 p 419)

varimax;

B = lding;

Bstar=B.^ppower; 

Tr=inv(B'*B)*B'*Bstar;

Tr=Tr*sqrt(inv(diag(diag(Tr'*Tr)))); % Normalizes columns of Tr

Tpp=inv(Tr);       % Tp' from definition

Tpp=inv(sqrt(diag(diag(Tpp*Tpp'))))*Tpp; % Normalizes rows of Tp'

Sr=B*Tr;           % Oblique reference structure

Phip=Tpp*Tpp';     % Correlation between primary factors  % Table 6.VI

Sp=B*Tpp';    % Primary Factor structure matrix Table 6.V

Pp=B*inv(Tpp); % Primary Factor pattern matrix Table 6.IV

Pr=B*inv(Tr');  % Reference pattern matrix

Phir=Tr'*Tr;    % Correlations between reference axes


if loadmat == 1; lding = Sp;end
if loadmat == 2; lding = Pp;end


